Index: src/analysis_correlation.hpp
===================================================================
--- src/analysis_correlation.hpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/analysis_correlation.hpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -72,4 +72,5 @@
   if (map == NULL) {
     eLog() << Verbose(0) << "Nothing to min/max, map is NULL!" << endl;
+    performCriticalExit();
     return;
   }
@@ -107,4 +108,5 @@
   if (map == NULL) {
     eLog() << Verbose(0) << "Nothing to bin, is NULL!" << endl;
+    performCriticalExit();
     return outmap;
   }
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/analyzer.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -94,5 +94,5 @@
   if (!Hcorrection.ParseFragmentMatrix(argv[1], "", HCORRECTIONSUFFIX,0,0)) {
     NoHCorrection = true;
-    Log() << Verbose(0) << "No HCorrection file found, skipping these." << endl;
+    eLog() << Verbose(2) << "No HCorrection file found, skipping these." << endl;
   }
   
@@ -100,9 +100,9 @@
   if (!Hessian.ParseFragmentMatrix(argv[1], dir, HessianSuffix,0,0)) {
     NoHessian = true;
-    Log() << Verbose(0) << "No Hessian file found, skipping these." << endl;
+    eLog() << Verbose(2) << "No Hessian file found, skipping these." << endl;
   }
   if (!Time.ParseFragmentMatrix(argv[1], dir, TimeSuffix, 10,1)) {
     NoTime = true;
-    Log() << Verbose(0) << "No speed file found, skipping these." << endl;
+    eLog() << Verbose(2) << "No speed file found, skipping these." << endl;
   }
   if (periode != NULL) { // also look for PAS values
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/atom_bondedparticle.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -44,11 +44,11 @@
 void BondedParticle::OutputBondOfAtom() const
 {
-  Log() << Verbose(4) << "Atom " << Name << "/" << nr << " with " << ListOfBonds.size() << " bonds: ";
+  Log() << Verbose(4) << "Atom " << Name << "/" << nr << " with " << ListOfBonds.size() << " bonds: " << endl;
   int TotalDegree = 0;
   for (BondList::const_iterator Runner = ListOfBonds.begin(); Runner != ListOfBonds.end(); ++Runner) {
-    Log() << Verbose(0) << **Runner << "\t";
+    Log() << Verbose(4) << **Runner << endl;
     TotalDegree += (*Runner)->BondDegree;
   }
-  Log() << Verbose(0) << " -- TotalDegree: " << TotalDegree << endl;
+  Log() << Verbose(4) << " -- TotalDegree: " << TotalDegree << endl;
 };
 
@@ -75,8 +75,8 @@
       status = true;
     } else {
-      Log() << Verbose(1) << "ERROR: " << *Binder << " does not contain " << *this << "." << endl;
+      eLog() << Verbose(1) << *Binder << " does not contain " << *this << "." << endl;
     }
   } else {
-    Log() << Verbose(1) << "ERROR: Binder is " << Binder << "." << endl;
+    eLog() << Verbose(1) << "Binder is " << Binder << "." << endl;
   }
   return status;
@@ -94,8 +94,8 @@
       status = true;
     } else {
-      Log() << Verbose(1) << "ERROR: " << *Binder << " does not contain " << *this << "." << endl;
+      eLog() << Verbose(1) << *Binder << " does not contain " << *this << "." << endl;
     }
   } else {
-    Log() << Verbose(1) << "ERROR: Binder is " << Binder << "." << endl;
+    eLog() << Verbose(1) << "Binder is " << Binder << "." << endl;
   }
   return status;
@@ -121,12 +121,12 @@
   bond *CandidateBond = NULL;
 
+  NoBonds = CountBonds();
   //Log() << Verbose(3) << "Walker " << *this << ": " << (int)this->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
-  NoBonds = CountBonds();
   if ((int)(type->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
     for (BondList::const_iterator Runner = ListOfBonds.begin(); Runner != ListOfBonds.end(); (++Runner)) {
       OtherWalker = (*Runner)->GetOtherAtom(this);
       OtherNoBonds = OtherWalker->CountBonds();
-      //Log() << Verbose(3) << "OtherWalker " << *OtherWalker << ": " << (int)OtherWalker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
-      if ((int)(OtherWalker->type->NoValenceOrbitals) > NoBonds) { // check if possible candidate
+      //Log() << Verbose(3) << "OtherWalker " << *OtherWalker << ": " << (int)OtherWalker->type->NoValenceOrbitals << " > " << OtherNoBonds << "?" << endl;
+      if ((int)(OtherWalker->type->NoValenceOrbitals) > OtherNoBonds) { // check if possible candidate
         if ((CandidateBond == NULL) || (ListOfBonds.size() > OtherWalker->ListOfBonds.size())) { // pick the one with fewer number of bonds first
           CandidateBond = (*Runner);
@@ -137,7 +137,7 @@
     if ((CandidateBond != NULL)) {
       CandidateBond->BondDegree++;
-      Log() << Verbose(2) << "Increased bond degree for bond " << *CandidateBond << "." << endl;
+      //Log() << Verbose(2) << "Increased bond degree for bond " << *CandidateBond << "." << endl;
     } else {
-      //Log() << Verbose(2) << "Could not find correct degree for atom " << *this << "." << endl;
+      eLog() << Verbose(2) << "Could not find correct degree for atom " << *this << "." << endl;
       FalseBondDegree++;
     }
Index: src/atom_graphnode.cpp
===================================================================
--- src/atom_graphnode.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/atom_graphnode.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -29,5 +29,5 @@
   Log() << Verbose(2) << "Atom " << Name << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ";
   OutputComponentNumber();
-  Log() << Verbose(0) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl;
+  Log() << Verbose(3) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl;
 };
 
@@ -40,5 +40,5 @@
   if (ComponentNr != NULL) {
     for (int i=0; ComponentNr[i] != -1; i++)
-      Log() << Verbose(0) << ComponentNr[i] << " ";
+      Log() << Verbose(2) << ComponentNr[i] << " ";
   }
 };
Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/atom_trajectoryparticle.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -203,5 +203,5 @@
         U[d] = gsl_ran_gaussian (r, sigma);
       }
-      Log() << Verbose(0) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl;
+      Log() << Verbose(2) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl;
     }
     for (int d=0; d<NDIM; d++)
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/bond.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -63,5 +63,5 @@
   if(rightatom == Atom) 
     return leftatom;
-  eLog() << Verbose(0) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl;
+  eLog() << Verbose(1) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl;
   return NULL;
 };
@@ -99,5 +99,5 @@
 bool bond::MarkUsed(const enum Shading color) {
   if (Used == black) {
-    eLog() << Verbose(0) << "ERROR: Bond " << this << " was already marked black!." << endl;
+    eLog() << Verbose(1) << "Bond " << this << " was already marked black!." << endl;
     return false;
   } else {
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/bondgraph.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -153,5 +153,5 @@
 {
   if (BondLengthMatrix == NULL) {// safety measure if no matrix has been parsed yet
-    eLog() << Verbose(1) << "WARNING:  BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl;
+    eLog() << Verbose(2) << "BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl;
     CovalentMinMaxDistance(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
   } else {
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/boundary.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -176,5 +176,5 @@
         angle = 0.; // otherwise it's a vector in Axis Direction and unimportant for boundary issues
 
-      //Log() << Verbose(0) << "Checking sign in quadrant : " << ProjectedVector.Projection(&AngleReferenceNormalVector) << "." << endl;
+      //Log() << Verbose(2) << "Checking sign in quadrant : " << ProjectedVector.Projection(&AngleReferenceNormalVector) << "." << endl;
       if (ProjectedVector.ScalarProduct(&AngleReferenceNormalVector) > 0) {
         angle = 2. * M_PI - angle;
@@ -214,10 +214,10 @@
     //      for(Boundaries::iterator runner = BoundaryPoints[axis].begin(); runner != BoundaryPoints[axis].end(); runner++) {
     //        if (runner != BoundaryPoints[axis].begin())
-    //          Log() << Verbose(0) << ", " << i << ": " << *runner->second.second;
+    //          Log() << Verbose(2) << ", " << i << ": " << *runner->second.second;
     //        else
-    //          Log() << Verbose(0) << i << ": " << *runner->second.second;
+    //          Log() << Verbose(2) << i << ": " << *runner->second.second;
     //        i++;
     //      }
-    //      Log() << Verbose(0) << endl;
+    //      Log() << Verbose(2) << endl;
     //    }
     // 3c. throw out points whose distance is less than the mean of left and right neighbours
@@ -249,28 +249,20 @@
           SideA.SubtractVector(MolCenter);
           SideA.ProjectOntoPlane(&AxisVector);
-          //          Log() << Verbose(0) << "SideA: ";
-          //          SideA.Output(out);
-          //          Log() << Verbose(0) << endl;
+          //          Log() << Verbose(0) << "SideA: " << SideA << endl;
 
           SideB.CopyVector(&right->second.second->x);
           SideB.SubtractVector(MolCenter);
           SideB.ProjectOntoPlane(&AxisVector);
-          //          Log() << Verbose(0) << "SideB: ";
-          //          SideB.Output(out);
-          //          Log() << Verbose(0) << endl;
+          //          Log() << Verbose(0) << "SideB: " << SideB << endl;
 
           SideC.CopyVector(&left->second.second->x);
           SideC.SubtractVector(&right->second.second->x);
           SideC.ProjectOntoPlane(&AxisVector);
-          //          Log() << Verbose(0) << "SideC: ";
-          //          SideC.Output(out);
-          //          Log() << Verbose(0) << endl;
+          //          Log() << Verbose(0) << "SideC: " << SideC << endl;
 
           SideH.CopyVector(&runner->second.second->x);
           SideH.SubtractVector(MolCenter);
           SideH.ProjectOntoPlane(&AxisVector);
-          //          Log() << Verbose(0) << "SideH: ";
-          //          SideH.Output(out);
-          //          Log() << Verbose(0) << endl;
+          //          Log() << Verbose(0) << "SideH: " << SideH << endl;
 
           // calculate each length
@@ -335,10 +327,10 @@
       for(Boundaries::iterator runner = BoundaryPoints[axis].begin(); runner != BoundaryPoints[axis].end(); runner++) {
         if (runner != BoundaryPoints[axis].begin())
-          Log() << Verbose(0) << ", " << i << ": " << *runner->second.second;
+          Log() << Verbose(2) << ", " << i << ": " << *runner->second.second;
         else
-          Log() << Verbose(0) << i << ": " << *runner->second.second;
+          Log() << Verbose(2) << i << ": " << *runner->second.second;
         i++;
       }
-      Log() << Verbose(0) << endl;
+      Log() << Verbose(2) << endl;
     }
 
@@ -347,5 +339,5 @@
     for (Boundaries::iterator runner = BoundaryPoints[axis].begin(); runner != BoundaryPoints[axis].end(); runner++)
         if (!TesselStruct->AddBoundaryPoint(runner->second.second, 0))
-          Log() << Verbose(3) << "WARNING: Point " << *(runner->second.second) << " is already present!" << endl;
+          eLog() << Verbose(2) << "Point " << *(runner->second.second) << " is already present!" << endl;
 
   Log() << Verbose(2) << "I found " << TesselStruct->PointsOnBoundaryCount << " points on the convex boundary." << endl;
@@ -355,7 +347,7 @@
   //  Log() << Verbose(1) << "Listing PointsOnBoundary:";
   //  for(PointMap::iterator runner = PointsOnBoundary.begin(); runner != PointsOnBoundary.end(); runner++) {
-  //    Log() << Verbose(0) << " " << *runner->second;
+  //    Log() << Verbose(1) << " " << *runner->second;
   //  }
-  //  Log() << Verbose(0) << endl;
+  //  Log() << Verbose(1) << endl;
 
   // 3a. guess starting triangle
@@ -406,5 +398,5 @@
         // flip the line
         if (TesselStruct->PickFarthestofTwoBaselines(line) == 0.)
-          Log() << Verbose(1) << "ERROR: Correction of concave baselines failed!" << endl;
+          eLog() << Verbose(1) << "Correction of concave baselines failed!" << endl;
         else {
           TesselStruct->FlipBaseline(line);
@@ -462,5 +454,5 @@
 
   if ((TesselStruct == NULL) || (TesselStruct->PointsOnBoundary.empty())) {
-    Log() << Verbose(2) << "ERROR: TesselStruct is empty." << endl;
+    eLog() << Verbose(1) << "TesselStruct is empty." << endl;
     return false;
   }
@@ -470,6 +462,6 @@
     Log() << Verbose(2) << "Remaining points are: ";
     for (PointMap::iterator PointSprinter = TesselStruct->PointsOnBoundary.begin(); PointSprinter != TesselStruct->PointsOnBoundary.end(); PointSprinter++)
-      Log() << Verbose(0) << *(PointSprinter->second) << "\t";
-    Log() << Verbose(0) << endl;
+      Log() << Verbose(2) << *(PointSprinter->second) << "\t";
+    Log() << Verbose(2) << endl;
 
     PointRunner = TesselStruct->PointsOnBoundary.begin();
@@ -528,5 +520,5 @@
   // check whether there is something to work on
   if (TesselStruct == NULL) {
-    Log() << Verbose(1) << "ERROR: TesselStruct is empty!" << endl;
+    eLog() << Verbose(1) << "TesselStruct is empty!" << endl;
     return volume;
   }
@@ -679,5 +671,5 @@
       OutputName.append(TecplotSuffix);
       ofstream *tecplot = new ofstream(OutputName.c_str());
-      WriteTecplotFile(tecplot, TesselStruct, mol, 0);
+      WriteTecplotFile(tecplot, TesselStruct, mol, -1);
       tecplot->close();
       delete(tecplot);
@@ -756,5 +748,5 @@
   Log() << Verbose(1) << "Minimum volume of the convex envelope contained in a rectangular box is " << minimumvolume << " atomicmassunit/" << (IsAngstroem ? "angstrom" : "atomiclength") << "^3." << endl;
   if (minimumvolume > cellvolume) {
-    eLog() << Verbose(0) << "ERROR: the containing box already has a greater volume than the envisaged cell volume!" << endl;
+    eLog() << Verbose(1) << "the containing box already has a greater volume than the envisaged cell volume!" << endl;
     Log() << Verbose(0) << "Setting Box dimensions to minimum possible, the greatest diameters." << endl;
     for (int i = 0; i < NDIM; i++)
@@ -849,9 +841,9 @@
   for(int i=0;i<NDIM;i++) {
     N[i] = (int) ceil(1./FillerDistance.x[i]);
-    Log() << Verbose(0) << N[i];
+    Log() << Verbose(1) << N[i];
     if (i != NDIM-1)
-      Log() << Verbose(0)<< ", ";
+      Log() << Verbose(1)<< ", ";
     else
-      Log() << Verbose(0) << "." << endl;
+      Log() << Verbose(1) << "." << endl;
   }
 
@@ -870,5 +862,5 @@
           // get linked cell list
           if (TesselStruct[i] == NULL) {
-            Log() << Verbose(1) << "ERROR: TesselStruct of " << (*ListRunner) << " is NULL. Didn't we pre-create it?" << endl;
+            eLog() << Verbose(1) << "TesselStruct of " << (*ListRunner) << " is NULL. Didn't we pre-create it?" << endl;
             FillIt = false;
           } else {
@@ -994,9 +986,10 @@
   while ((baseline != TesselStruct->LinesOnBoundary.end()) || (OneLoopWithoutSuccessFlag)) {
     if (baseline->second->triangles.size() == 1) {
+      CheckListOfBaselines(TesselStruct);
       // 3. find next triangle
       TesselationFailFlag = TesselStruct->FindNextSuitableTriangle(*(baseline->second), *(((baseline->second->triangles.begin()))->second), RADIUS, LCList); //the line is there, so there is a triangle, but only one.
       OneLoopWithoutSuccessFlag = OneLoopWithoutSuccessFlag || TesselationFailFlag;
       if (!TesselationFailFlag)
-        eLog() << Verbose(0) << "WARNING: FindNextSuitableTriangle failed." << endl;
+        eLog() << Verbose(2) << "FindNextSuitableTriangle failed." << endl;
 
       // write temporary envelope
@@ -1006,10 +999,15 @@
         }
       }
-      baseline = TesselStruct->LinesOnBoundary.end();
-      Log() << Verbose(2) << "Baseline set to end." << endl;
+      if (TesselationFailFlag) {
+        baseline = TesselStruct->LinesOnBoundary.begin();
+        OneLoopWithoutSuccessFlag = false;
+        Log() << Verbose(2) << "Baseline set to begin." << endl;
+      }
     } else {
       //Log() << Verbose(1) << "Line " << *baseline->second << " has " << baseline->second->triangles.size() << " triangles adjacent" << endl;
-      if (baseline->second->triangles.size() != 2)
-        Log() << Verbose(1) << "ERROR: TESSELATION FINISHED WITH INVALID TRIANGLE COUNT!" << endl;
+      if (baseline->second->triangles.size() != 2) {
+        eLog() << Verbose(0) << "TESSELATION FINISHED WITH INVALID TRIANGLE COUNT!" << endl;
+        performCriticalExit();
+      }
     }
 
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/boundary.hpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -35,5 +35,5 @@
 
 #define DEBUG 1
-#define DoSingleStepOutput 0
+#define DoSingleStepOutput 1
 #define SingleStepWidth 1
 
